#include <iostream>
#include <fstream>

using namespace std;

const int MAXNUM = 100;
const int MAXL = 50;

enum Classe {PRIMA, BUSINESS, ECONOMICA};
enum Sesso {M, F};

struct Passeggero {
  char nome[MAXL];
  char cognome[MAXL];
  Sesso sex;
};

struct Biglietto {
  Passeggero pass;
  Classe cl;
  int volo;
  int pos;
};

struct GestioneBigl {
  Biglietto big[MAXNUM];
  int numBigl;
};


int quanti(const GestioneBigl* gb, Sesso s); 
int perClasse(const GestioneBigl* gb, Classe c, Biglietto vet[]);
bool presente(const GestioneBigl* gb, char n[], char c[], int* pv, int* pp);
void salvaOrd(const GestioneBigl* gb, const char nf[], int v);
int elimina(GestioneBigl* gb, int v);

void stampa(Biglietto b) {
  cout << b.pass.cognome << ", " << b.pass.nome << ", " <<
        (b.pass.sex == M ? 'M' : 'F') << ", ";
  switch(b.cl) {
    case PRIMA:
      cout << "PRIMA ";  
      break;
    case BUSINESS:
      cout << "BUS. ";
      break;
    case ECONOMICA:
      cout << "ECON. ";
      break;
  }
  cout << b.volo << ", " << b.pos << endl;
}

void load(GestioneBigl* pg, char nf[]){
  fstream fs;
  fs.open(nf, ios::in);
  if(!fs) {
    cerr << "Errore: file con i dati iniziali non trovato" << endl;
    exit(1);
  } 
  char cc, dd;
  while(pg->numBigl < MAXNUM && 
        fs >> pg->big[pg->numBigl].pass.cognome 
           >> pg->big[pg->numBigl].pass.nome
           >> cc
           >> dd
           >> pg->big[pg->numBigl].volo
           >> pg->big[pg->numBigl].pos) {
    pg->big[pg->numBigl].pass.sex = cc == 'M' ? M : F;
    switch(dd) {
      case 'P':
        pg->big[pg->numBigl].cl = PRIMA;
        break;
      case 'B':
        pg->big[pg->numBigl].cl = BUSINESS;
        break;
      case 'E':
        pg->big[pg->numBigl].cl = ECONOMICA;
        break;
    }
    pg->numBigl++;
  }
}

int main(){
  GestioneBigl gg;
  gg.numBigl = 0;
  
  load(&gg, "input.txt");
  
  cout << "Il numero di biglietti relativi\na passeggeri di sesso maschile e': " 
       << quanti(&gg, M) << endl; 
  cout << "Il numero di biglietti relativi\na passeggeri di sesso femminile e': " 
       << quanti(&gg, F) << endl; 
  system("pause");

  cout << endl << endl;
  Biglietto vv[MAXNUM];
  cout << "I biglietti di classe ECONOMICA sono:\n";
  int n  = perClasse(&gg, ECONOMICA, vv);
  for(int i=0; i<n; i++)
    stampa(vv[i]); 
  system("pause");
  cout << "I biglietti di classe PRIMA sono:\n";
  n  = perClasse(&gg, PRIMA, vv);
  for(int i=0; i<n; i++)
    stampa(vv[i]); 
  system("pause");
 
  cout << endl << endl;
  int volo, posiz;
  if(presente(&gg, "Mario", "Rossi", &volo, &posiz)) 
    cout << "Passeggero Mario Rossi: volo=" << volo << " pos=" << posiz << endl; 
  else
    cout << "Il passeggero Mario Rossi non e' presente\n"; 
  if(presente(&gg, "Luigi", "Bianchi", &volo, &posiz)) 
    cout << "Passeggero Luigi Bianchi: volo=" << volo << " pos=" << posiz << endl; 
  else
    cout << "Il passeggero Luigi Bianchi non e' presente\n"; 
  if(presente(&gg, "Giuseppe", "Bottone", &volo, &posiz)) 
    cout << "Passeggero Giuseppe Bottone: volo=" << volo << " pos=" << posiz << endl; 
  else
    cout << "Il passeggero Giuseppe Bottone non e' presente\n"; 
  system("pause");  

  cout << endl << endl;
  cout << "Salvo i dati del volo 234 in \"output.txt\"\n";
  salvaOrd(&gg, "output.txt", 234);
  cout << "Contenuto di output.txt:\n";
  system("type output.txt");
  system("pause");

  cout << endl << endl;
  cout << "Elimino i biglietti relativi al volo 555\n";
  int q = elimina(&gg, 555);
  cout << "Ho eliminato " << q << " biglietti\n";
  cout << "Adesso lo stato del sistema e':\n";
  for(int i=0; i<gg.numBigl; i++)
    stampa(gg.big[i]);
  system("pause");
}
