#include <iostream>
#include <fstream>

using namespace std;

const int MAXNUM = 100;
const int MAXL = 50;

enum Classe {PRIMA, BUSINESS, ECONOMICA};
enum Sesso {M, F};

struct Passeggero {
  char nome[MAXL];
  char cognome[MAXL];
  Sesso sex;
};

struct Biglietto {
  Passeggero pass;
  Classe cl;
  int volo;
  int pos;
};

struct GestioneBigl {
  Biglietto big[MAXNUM];
  int numBigl;
};


int quanti(const GestioneBigl* gb, Sesso s) {
  int conta = 0;
  for(int i=0; i<gb->numBigl; i++)
    if(gb->big[i].pass.sex == s)
      conta ++;
  return conta;
}

int perClasse(const GestioneBigl* gb, Classe c, Biglietto vet[]) {
  int conta = 0;
  for(int i=0; i<gb->numBigl; i++)
    if(gb->big[i].cl == c)
      vet[conta++] = gb->big[i];
  return conta;
}

bool presente(const GestioneBigl* gb, char n[], char c[], int* pv, int* pp) {
  for(int i=0; i<gb->numBigl; i++)
    if(strcmp(gb->big[i].pass.cognome, c) == 0 && 
       strcmp(gb->big[i].pass.nome, n) == 0) {
      *pv = gb->big[i].volo;
      *pp = gb->big[i].pos;
      return true;
    }
  return false;
}

void scambia(Passeggero vv[], int x, int y) {
  Passeggero tmp = vv[x];
  vv[x] = vv[y];
  vv[y] = tmp;
}

void ordina(Passeggero pv[], int n){
  bool ordinato = false;
  for(int i=0; i<n-1 && !ordinato; i++) {
    ordinato = true;
    for(int j=n-1; j>=i+1; j--)
      if(strcmp(pv[j].cognome, pv[j-1].cognome) < 0) {
        scambia(pv, j, j-1);
        ordinato = false;
      }
  }
}


void salvaOrd(const GestioneBigl* gb, const char nf[], int v) {
  fstream ff;
  ff.open(nf, ios::out);
  
  if(!ff) {
    cerr << "Errore nell'apertura del file.\n";
    exit(1);
  }
  int conta = 0;
  Passeggero app[MAXNUM];
  for(int i=0; i<gb->numBigl; i++)
    if(gb->big[i].volo == v)
      app[conta++] = gb->big[i].pass;

  ordina(app, conta);
  for(int i=0; i<conta; i++)
    ff << app[i].cognome << ", " << app[i].nome << '\n';
}

int elimina(GestioneBigl* gb, int v) {
  int conta = 0;
  for(int i=0; i<gb->numBigl; i++)
    if(gb->big[i].volo == v) {
      for(int j=i; j<gb->numBigl - 1; j++)
        gb->big[j] = gb->big[j+1];
      gb->numBigl--;
      i--;
      conta ++;
    }
  return conta;
}
